<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: tools/data/data.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: tools/data/data.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>const tool = require('../tool.js')
var schema = require('./schema.json')
const medley = require('../../medley.js')
const JSON5 = require('json5')

/**
* install request API for all custom collections the game contains
*/
class Data extends tool.Tool {
  constructor() {
    super(schema)
    this.name = "data"
    this.collection_apis = []
  }

  /**
  * create request API for each custom database
  */
  setup(config) {
    super.setup(config)

    if (this.hasOwnProperty("custom_collections")) {
      if (this.custom_collections) {
        for (let collection of this.custom_collections) {
          if (!this.db.hasOwnProperty(collection)) {
            log.error(this.name, collection + " not found")
            break
          }
          this.collection_apis.push(new CollectionAPI(this.db[collection], this.app, this.game))
        }
      }
    }

    return schema
  }

  cue(data, session) {
    return new Promise((resolve, reject) => {
      for (let item in data) {
        switch (item) {
          case "store":
            this.store(data[item], session)
              .then(result => {
                return resolve(result) // always undefined
              })
              .catch(error => {
                log.error(this.name, error)
                return resolve(undefined)
              })
            break
        }
      }
    })
  }

  store(properties, session) {
    return new Promise((resolve, reject) => {
      let name = session.name + " store"
      if (properties.hasOwnProperty("update")) {
        var ref = session.variables.getReference(properties.document)

        session.variables.review(properties.update)
          .then(result => {
            try {
              var update = JSON5.parse(result)
            } catch (err) {
              log.error(name, "couldn't store " + result + ". Not a valid JSON")
              throw new Error(err)
            }
            log.info(name, "Store " + result + " to " + ref.collection + " " + JSON.stringify(ref.query))
            return this.db[ref.collection].update(ref.query, update)
          })
          .then(res => {
            log.debug(name, " matched: " + res.matchedCount + ", modiified: " + res.modifiedCount)
            return resolve(undefined)
          })
          .catch(error => {
            log.error(name, error)
            return resolve(undefined)
          })
      } else if (properties.hasOwnProperty("set")) {
        var ref = session.variables.getReference(properties.document)
        var store_promises = []
        for (let key in properties.set) {
          store_promises.push(this.setValue(key, properties.set[key], ref, session))
        }
        Promise.all(store_promises)
          .then(result => {
            let modified = 0
            let matched = 0
            for (let res of result) {
              modified += res.modifiedCount
              matched += res.matchedCount
            }
            log.debug(name, "changed " + modified + " of " + matched + " entries")
            return resolve(undefined)
          })
          .catch(error => {
            log.error(this.name, error)
            return resolve(undefined)
          })
      } else {
        log.warn(name, "Properties missing store action")
        return resolve(undefined)
      }
    })
  }

  setValue(key, value, ref, session) {
    return new Promise((resolve, reject) => {
      session.variables.review(value)
        .then(result => {
          let update = {}
          update[key] = result
          return this.db[ref.collection].set(ref.query, update)
        })
        .then(res => {
          return resolve(res)
        })
        .catch(error => {
          log.error("set value", error)
          return resolve(undefined)
        })
    })
  }

  /////////////////////////////////////////////////////// DEPRECATED
  /**
  * write data to status collection
  */

  storeDeprecated(data) {
    log.info("DATA", data)
    if (data.hasOwnProperty('_target')) {
      if (typeof data._target === 'string') {
        var target = { "name": data._target }
      } else {
        var target = data._target
      }
      delete data._target
    } else {
      var target = { 'name': 'grace' }
    }

    let promises = []
    if (typeof (data) === "string") {
      let store_data = this.toJSON(data)
      log.info("STORE", store_data)
      this.status.updateNoSet(target, store_data)
      return
    } else {
      for (let item in data) {
        promises.push(this.replaceVariables(item, data[item]))
      }
    }

    let store_data = {}
    Promise.all(promises)
      .then(function (result) {

        for (let res of result) {

          Object.assign(store_data, res)
        }

        log.info("STORE", store_data)

        this.status.set(target, store_data)
      }.bind(this))


  }

  replaceVariables(key, prop) {
    return new Promise(function (resolve, reject) {
      var ret = {}

      if (typeof (prop) === "string") {
        if (prop.match(/{{([^}]+)}}/)) {
          this.status.find({ "sessions": this.name })
            .then(function (result) {

              ret[key] = medley.mustache(prop, result[0])
              log.info("RES", result[0])
              ret[key] = this.toJSON(ret[key])
              resolve(ret)
            }.bind(this))
            .catch(function (error) {
              log.error(this.name, error)
            }.bind(this))
        } else {
          ret[key] = this.toJSON(prop)
          resolve(ret)
        }
      } else {
        ret[key] = this.toJSON(prop)
        resolve(ret)
      }
    }.bind(this))
  }

  toJSON(str) {
    if (typeof str === 'string') {
      try {
        return (JSON5.parse(str))
      } catch (err) {
        return (str)
        log.warn(this.name, 'error when parsing string to json. Will save data as single string, overwriting existing data.')
        //log.debug(this.name, err)
      }
    } else {
      return (str)
    }
  }

}

/**
* creates express app routing to enable requests to interface with mongodb collection
*
* @param {Object} collection - mongodb collection interface
* @param {Object} app - express app as forwarded form index.js
* @param {string} game - game name to create game specific routing (/&lt;game>/&lt;collection>)
*/
class CollectionAPI {
  constructor(collection, app, game) {
    this.name = collection.name + "API"
    this.collection = collection
    app.get('/' + game + '/' + collection.name, this.incomming.bind(this))
  }

  /**
  * deal with requests
  */
  incomming(req, res) {
    //log.info(this.name, req.headers.host)
    let prom
    if (!medley.isEmpty(req.body)) {
      log.info(this.name, req.body)
      prom = this.handle(req.body)
    } else if (!medley.isEmpty(req.query)) {
      prom = this.handle(req.query)
    } else {
      log.warn(this.name, "Request with no body or query data. Headers:")
      log.warn(this.name, req.headers)
      log.warn(this.name, req.query)
      log.warn(this.name, req.body)
      throw new Error("content missing")
    }
    prom.then(result => {
      res.status(200)
      res.send(result)
    })
      .catch(error => {
        res.status(400)
        res.send(error)
        log.warn(this.name, error)
      })
  }

  /**
  * try to interface with mongo collection
  *
  * @param {Object} data - request data from body or query
  */
  handle(data) {
    return new Promise((resolve, reject) => {
      log.debug(this.name, data)
      if (data.hasOwnProperty("set") &amp;&amp; data.hasOwnProperty("key")) {
        let query = {}
        query[data.key] = data.set
        delete data.set
        delete data.key

        for (let d in data) {
          if (data[d][0] == '{') {
            try {
              data[d] = JSON5.parse(data[d])
            } catch (err) {
              if (err instanceof SyntaxError) {
                log.warn(this.name, 'syntax error in query "' + data[d] + '"')
              } else {
                log.error(this.name, 'Error when parsing to json:')
                log.error(this.name, err)
              }
              return reject("error when parsing json: " + err.message)
            }
          }
        }

        return resolve(this.collection.set(query, data))
      } else if (data.hasOwnProperty("get")) {
        var key = data.get
        delete data.get
        this.collection.find(data)
          .then(result => {
            for (let res of result) {
              if (res.hasOwnProperty(key)) {
                return resolve(res[key])
              } else if (key == "all") {
                return resolve(res)
              } else {
                return reject("no such key: " + key)
              }
            }
            return reject("not found")
          })
      } else if (data.hasOwnProperty("getMany")) {
        var key = data.getMany
        delete data.getMany
        this.collection.find(data)
          .then(result => {
            if (result.length) {
              let ret_val = []
              for (let res of result) {
                if (res.hasOwnProperty(key)) {
                  ret_val.push(res[key])
                } else if (key == "all") {
                  ret_val.push(res)
                } else {
                  ret_val.push(undefined)
                }
              }
              return resolve(ret_val)
            } else {
              return reject("not found")
            }
          })
      } else {
        return reject("property missing")
      }
    })
  }
}

module.exports.Plaitool = Data
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tool.html">tool</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-tool-Collection.html">Collection</a></li><li><a href="module-tool-Item.html">Item</a></li><li><a href="module-tool-Tool.html">Tool</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Thu Dec 12 2019 19:18:46 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
